'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Immutable = require('immutable');
var assert = require('assert');

var NO_VALUES = '\n  Trying to build entry without values.\n'.trim();

var NO_TRANSACTION = '\n  Trying to change model without a transaction.\n  Make sure you are inside an action.\n'.trim();

var createObjectManagerConstructor = function createObjectManagerConstructor(QuerySetConstructor) {
  return function (_QuerySetConstructor) {
    _inherits(_class, _QuerySetConstructor);

    function _class(_ref) {
      var setup = _ref.setup,
          values = _ref.values,
          _ref$transaction = _ref.transaction,
          transaction = _ref$transaction === undefined ? null : _ref$transaction;

      _classCallCheck(this, _class);

      var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, { QuerySetConstructor: QuerySetConstructor, values: values }));

      _this.manager = _this;
      _this.transaction = transaction;
      _this.setup = setup;
      return _this;
    }

    _createClass(_class, [{
      key: 'build',
      value: function build() {
        var values = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Immutable.Map();

        assert.ok(values && values instanceof Immutable.Map, NO_VALUES);

        var EntryConstructor = this.setup.get('EntryConstructor');
        return new EntryConstructor({ values: values, manager: this, setup: this.setup });
      }
    }, {
      key: 'get',
      value: function get(expression) {
        return typeof expression === 'string' ? this.build(this.values.get(expression)) : _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'get', this).call(this, expression);
      }
    }, {
      key: 'create',
      value: function create() {
        var rawValues = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        var entry = this.build();

        entry.save();
        entry.update(rawValues);

        return entry;
      }
    }, {
      key: 'getOrCreate',
      value: function getOrCreate(expression) {
        return this.get(expression) || this.create(expression);
      }
    }, {
      key: 'sync',
      value: function sync(values) {
        assert.ok(this.transaction, NO_TRANSACTION);
        return this.transaction.sync(values);
      }
    }, {
      key: 'unsync',
      value: function unsync(values) {
        assert.ok(this.transaction, NO_TRANSACTION);
        return this.transaction.unsync(values);
      }
    }, {
      key: 'values',
      get: function get() {
        return this.transaction ? this.transaction.values : this.inputValues;
      }
    }]);

    return _class;
  }(QuerySetConstructor);
};

module.exports = {
  createObjectManagerConstructor: createObjectManagerConstructor
};
